!c Description: 
!c   $BCO7A$N8z2L$N7W;;(B
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-11-01    $B9b66$3$&;R(B $B:n@.(B
!c   1.1        2003-11-12    $B?y;39L0lO/(B $B=$@5(B
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module if_jacobian
  interface

     subroutine jacobian(g,g_z,g13,g13_x,g13_z,g13_xz)
       real(8), intent(out) :: g(:,:)    ! $B%d%3%S%"%s$N(B1/2$B>h(B
       real(8), intent(out) :: g_z(:,:)
       real(8), intent(out) :: g13(:,:)  ! $B%d%3%S%"%s$N(B13$B@.J,(B
       real(8), intent(out) :: g13_x(:,:)
       real(8), intent(out) :: g13_z(:,:)
       real(8), intent(out) :: g13_xz(:,:)
     end subroutine jacobian
     
  end interface
end module if_jacobian


subroutine jacobian(g,g_z,g13,g13_x,g13_z,g13_xz)
  implicit none

  real(8), intent(out) :: g(:,:)    ! $B%d%3%S%"%s$N(B1/2$B>h(B
  real(8), intent(out) :: g_z(:,:)
  real(8), intent(out) :: g13(:,:)  ! $B%d%3%S%"%s$N(B13$B@.J,(B
  real(8), intent(out) :: g13_x(:,:)
  real(8), intent(out) :: g13_z(:,:)
  real(8), intent(out) :: g13_xz(:,:)  
  
  !$B8=:_$O%U%i%C%H$JCO7A$r2>Dj(B
  g = 1.0d0
  g_z = 1.0d0
  g13 = 0.0d0
  g13_x = 0.0d0
  g13_z = 0.0d0
  g13_xz = 0.0d0

  
!  g(i,k) =  (h - zs(i))/h
  
!  g13(i,k) = (z(i,k) - h)/(h - zs(i))   &
!       &     *(zs(i) - zs(i-1))/dx

!  g_z(i,k) = (g(i,k+1) + g(i,k))/2.0d0
!  
!  g13_x(i,k) = (g13(i+1,k) + g13(i,k))/2
!  
!  g13_z(i,k) = (g13(i,k+1) + g13(i,k))/2
!  
!  g13_xz(i,k) = (                              &
!       &        g13(i+1,k+1) + g13(i-1,k+1)    &
!       &        + g13(i+1,k-1) + g13(i-1,k-1)  &
!       &       )/4.0d0
  
end subroutine jacobian

